# bash programmable completion for various Common Lisp implementations by
# Nikodemus Siivola <nikodemus@random-state.net>
#
# $Id: lisp,v 1.2 2004/03/30 23:05:45 ianmacd Exp $

_lisp()
{
    local cur

    COMPREPLY=()
    cur=${COMP_WORDS[COMP_CWORD]}

    # completing an option (may or may not be separated by a space)
    if [[ "$cur" == -* ]]; then
	COMPREPLY=( $( compgen -W '-core -lib -batch -quit -edit -eval -init \
                     -dynamic-space-size -hinit -noinit -nositeinit -load \
                     -slave ' \
                     -- $cur ) )
    else
	_filedir
    fi

    return 0
}
complete -F _lisp -o default lisp
